module.exports = {
  "extends": ["tslint-eslint-rules"],
  "rules": {

    // tslint

    "adjacent-overload-signatures": true,
    "align": [true, "arguments", "parameters", "statements", "elements", "members"],
    "array-type": [true, "array"],
    "arrow-parens": [true, "ban-single-arg-parens"],
    "arrow-return-shorthand": [true, "multiline"],
    "await-promise": true,
    "ban": false,
    "ban-types": [true,
      ["Boolean", "Use boolean instead."],
      ["Number", "Use number instead."],
      ["String", "Use string instead."],
      ["Object", "Use {} instead."]
    ],
    "callable-types": true,
    "class-name": true,
    "comment-format": [true, "check-space"],
    "completed-docs": [false],
    "curly": true,
    "cyclomatic-complexity": [true, 20],
    "deprecation": true,
    "encoding": true,
    "eofline": true,
    "file-header": [false],
    "forin": true,
    "import-blacklist": false,
    "import-spacing": true,
    "indent": [true, "spaces", 2],
    "interface-name": [true, "always-prefix"],
    "interface-over-type-literal": true,
    "jsdoc-format": true,
    "label-position": true,
    "linebreak-style": [true, "LF"],
    "match-default-export-name": true,
    "max-classes-per-file": [true, 1],
    "max-file-line-count": [true, 300],
    "max-line-length": [true, 120],
    "member-access": true,
    "member-ordering": [true, { "order": [
      "public-static-field",
      "protected-static-field",
      "private-static-field",
      "public-instance-field",
      "protected-instance-field",
      "private-instance-field",
      "constructor",
      "public-static-method",
      "protected-static-method",
      "private-static-method",
      "public-instance-method",
      "protected-instance-method",
      "private-instance-method"
    ]}],
    "new-parens": true,
    "newline-before-return": false,
    "no-angle-bracket-type-assertion": true,
    "no-any": false,
    "no-arg": true,
    "no-bitwise": true,
    "no-boolean-literal-compare": true,
    "no-conditional-assignment": true,
    "no-consecutive-blank-lines": [true],
    "no-console": [true],
    "no-construct": true,
    "no-debugger": true,
    "no-default-export": true,
    "no-duplicate-super": true,
    "no-duplicate-variable": true,
    "no-empty": true,
    "no-empty-interface": true,
    "no-eval": true,
    "no-floating-promises": true,
    "no-for-in-array": true,
    "no-import-side-effect": true,
    "no-inferrable-types": [true, "ignore-params", "ignore-properties"],
    "no-inferred-empty-object-type": true,
    "no-internal-module": true,
    "no-invalid-template-strings": true,
    "no-invalid-this": true,
    "no-irregular-whitespace": true,
    "no-magic-numbers": true,
    "no-mergeable-namespace": true,
    "no-misused-new": true,
    "no-namespace": [true, "allow-declarations"],
    "no-non-null-assertion": true,
    "no-null-keyword": false,
    "no-object-literal-type-assertion": true,
    "no-parameter-properties": true,
    "no-reference": true,
    "no-reference-import": true,
    "no-require-imports": true,
    "no-shadowed-variable": true,
    "no-sparse-arrays": true,
    "no-string-literal": true,
    "no-string-throw": true,
    "no-switch-case-fall-through": true,
    "no-trailing-whitespace": true,
    "no-unbound-method": true,
    "no-unnecessary-callback-wrapper": true,
    "no-unnecessary-initializer": true,
    "no-unnecessary-qualifier": true,
    "no-unnecessary-type-assertion": true,
    "no-unsafe-any": false,
    "no-unsafe-finally": true,
    "no-unused-expression": true,
    "no-unused-variable": [true, { "ignore-pattern": "^_" }],
    "no-use-before-declare": true,
    "no-var-keyword": true,
    "no-var-requires": true,
    "no-void-expression": [true, "ignore-arrow-function-shorthand"],
    "number-literal-format": true,
    "object-literal-key-quotes": [true, "consistent-as-needed"],
    "object-literal-shorthand": true,
    "object-literal-sort-keys": false,
    "one-line": [true,
      "check-open-brace",
      "check-catch",
      "check-else",
      "check-finally",
      "check-whitespace"
    ],
    "one-variable-per-declaration": [true],
    "only-arrow-functions": [true,
      "allow-declarations",
      "allow-named-functions"
    ],
    "ordered-imports": [true, {"import-sources-order": "lowercase-first", "named-imports-order": "lowercase-first"}],
    "prefer-conditional-expression": true,
    "prefer-const": true,
    "prefer-for-of": true,
    "prefer-function-over-method": true,
    "prefer-method-signature": true,
    "prefer-object-spread": true,
    "prefer-switch": [false],
    "prefer-template": true,
    "promise-function-async": true,
    "quotemark": [true, "single", "avoid-escape", "jsx-double", "no-template"],
    "radix": false,
    "restrict-plus-operands": true,
    "return-undefined": true,
    "semicolon": [true, "always"],
    "space-before-function-paren": [true, {
      "anonymous": "always",
      "asyncArrow": "always",
      "constructor": "never",
      "method": "never",
      "named": "never"
    }],
    "strict-boolean-expressions": [true,
      "allow-null-union",
      "allow-undefined-union"
    ],
    "strict-type-predicates": true,
    "switch-default": true,
    "trailing-comma": [true, { "multiline": "always", "singleline": "never" }],
    "triple-equals": true,
    "typedef": [false],
    "typedef-whitespace": [true, {
      "call-signature": "nospace",
      "index-signature": "nospace",
      "parameter": "nospace",
      "property-declaration": "nospace",
      "variable-declaration": "nospace"
    }, {
      "call-signature": "onespace",
      "index-signature": "onespace",
      "parameter": "onespace",
      "property-declaration": "onespace",
      "variable-declaration": "onespace"
    }],
    "typeof-compare": true,
    "unified-signatures": true,
    "use-isnan": true,
    "variable-name": [true,
      "ban-keywords",
      "check-format",
      "allow-snake-case",
      "allow-leading-underscore"
    ],
    "whitespace": [true,
      "check-branch",
      "check-decl",
      "check-operator",
      "check-module",
      "check-preblock",
      "check-separator",
      "check-type",
      "check-typecast"
    ],

    // tslint-eslint-rules

    // "arrow-body-style": [false], // tslint: arrow-return-shorthand
    "array-bracket-spacing": [true, "never"],
    "block-spacing": [true, "always"],
    // "brace-style": [false], // tslint: one-line
    "handle-callback-err": [true, "^(err|error)$|^.+Error$", { "allowProperties": true }],
    "no-constant-condition": true,
    "no-control-regex": true,
    "no-duplicate-case": true,
    "no-empty-character-class": true,
    "no-ex-assign": true,
    "no-extra-boolean-cast": true,
    "no-extra-semi": true,
    "no-inner-declarations": [true, "both"],
    "no-invalid-regexp": true,
    "no-multi-spaces": [true, { "exceptions": {
      "PropertyAssignment": false,
      "VariableDeclaration": false,
      "BinaryExpression": false
    }}],
    "no-regex-spaces": true,
    "no-unexpected-multiline": true,
    "object-curly-spacing": [true, "never"],
    // "sort-imports": [false], // tslint: ordered-imports
    "space-in-parens": [true, "never"],
    // "ter-arrow-parens": [false], // tslint: arrow-parens
    // "ter-arrow-spacing": [false], // tslint: whitespace
    "ter-func-call-spacing": [true, "never"],
    "ter-indent": [true, 2, {
      "SwitchCase": 1,
      "VariableDeclarator": 1,
      "outerIIFEBody": 1,
      "MemberExpression": 1,
      "FunctionDeclaration": {
        "parameters": 2,
        "body": 1
      },
      "FunctionExpression": {
        "parameters": 2,
        "body": 1
      },
      "CallExpression": {
        "arguments": 1
      }
    }],
    // "ter-max-len": [false], // tslint: max-line-length
    // "ter-no-irregular-whitespace": false, // tslint: no-irregular-whitespace
    // "ter-no-sparse-arrays": false, // tslint: no-sparse-arrays
    // "ter-prefer-arrow-callback": [false], // tslint: only-arrow-functions
    "valid-jsdoc": [false]
    // "valid-typeof": false, // tslint: typeof-compare
  }
};
